Description

I have a PivotQuery, it's a subclass of IssueQuery.

But Query don't think it is subclass of himself.

So, r15635 let my plugin down.

I changed QueriesController to fix it.

OLD CODE:

def query_class

  Query.get_subclass(params[:type] || 'IssueQuery')

end

New Code

def query_class

  get_query_class(params[:type] || 'IssueQuery')

end

def get_query_class(class_name)

  klass = nil

  begin

    klass = class_name.to_s.classify.constantize

  rescue

    # invalid class name

  end

  unless klass && klass.new.is_a?(Query)

    klass = nil

  end

  klass    

end

Associated revisions

Revision 18754 - 2019-10-19 12:13 - Jean-Philippe Lang

Fixed that QueriesController can not handle subclass of IssueQuery (#25265).

History

#1 - 2017-03-08 04:56 - Haihan Ji

Maybe klass < Query is better than klass && klass.new.is_a?(Query).

#2 - 2017-03-08 22:46 - Jean-Philippe Lang

We should be able to fix get_subclass instead:

Index: lib/redmine/subclass_factory.rb

===================================================================

--- lib/redmine/subclass_factory.rb    (revision 16379)

+++ lib/redmine/subclass_factory.rb    (working copy)

@@ -29,7 +29,7 @@

         rescue
           # invalid class name

         end

-        unless subclasses.include? klass

+        unless descendants.include? klass

           klass = nil

         end

         klass

 Would it work for you?

#3 - 2019-09-06 10:25 - Alexander Meindl

Hi Jean-Philippe,

your suggested change would be fix problems for some plugins, which I maintain. It would be nice to get this change in a upcoming release.

#4 - 2019-09-06 13:01 - Go MAEDA

- Assignee set to Jean-Philippe Lang

- Target version set to 4.1.0

#5 - 2019-10-19 12:13 - Jean-Philippe Lang

- Status changed from New to Closed

#6 - 2020-02-27 12:18 - Alexander Meindl

This change is only available in trunk, but not in Branch 4.1-stable - as this issue shows. Can we get this to 4.1-stable branch?

#7 - 2020-02-27 12:47 - Marius BĂLTEANU

Alexander Meindl wrote:

This change is only available in trunk, but not in Branch 4.1-stable - as this issue shows. Can we get this to 4.1-stable branch?

 It is already on 4.1-stable branch, pleasee source:branches/4.1-stable/lib/redmine/subclass_factory.rb#L34.

#8 - 2020-02-27 12:58 - Alexander Meindl

You are right! Sorry for bothering you about this.
